## obs-advanced-scene-switcher 1.32.8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21...3.26)

project(advanced-scene-switcher VERSION 1.0.0)

message(STATUS "CMAKE_PROJECT_NAME is ${CMAKE_PROJECT_NAME}")
if(${CMAKE_PROJECT_NAME} STREQUAL "obs-studio")
  if(NOT DEFINED BUILD_OUT_OF_TREE)
    message(STATUS "${PROJECT_NAME} configured for in-tree build")
  endif()
else()
  set(BUILD_OUT_OF_TREE ON)
  message(STATUS "${PROJECT_NAME} configured for out-of-tree build")
endif()

if(BUILD_OUT_OF_TREE)
  include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/common/bootstrap.cmake"
          NO_POLICY_SCOPE)
  include(compilerconfig)
  include(defaults)
  include(helpers)
endif()

# OBS 31 no longer defines find_qt so check if we need to include it for in-tree
# builds
if(NOT COMMAND find_qt)
  include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/common/helpers_common.cmake")
endif()

set(LIB_NAME "${PROJECT_NAME}-lib")
add_library(${PROJECT_NAME} MODULE)
add_library(${LIB_NAME} SHARED)

include(cmake/common/get_git_revision_description.cmake)
get_git_head_revision(GIT_REFSPEC GIT_SHA1)
git_describe(GIT_TAG)

# Helper for OpenSSL
if(OS_WINDOWS)
  include(cmake/windows/wingetssl.cmake)
endif()

if(${GIT_TAG} STREQUAL "GIT-NOTFOUND")
  set(GIT_TAG ${PROJECT_VERSION})
endif()
message(STATUS "${PROJECT_NAME} version: ${GIT_TAG}")
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/common/version.cpp.in"
               "${CMAKE_CURRENT_BINARY_DIR}/lib/version.cpp" @ONLY)

# --- Set target sources ---

# Module sources
target_sources(${PROJECT_NAME} PRIVATE module/advanced-scene-switcher-module.c)

# Generic sources
target_sources(
  ${LIB_NAME}
  PRIVATE lib/advanced-scene-switcher.cpp
          lib/advanced-scene-switcher.hpp
          lib/general.cpp
          lib/platform-funcs.hpp
          lib/switcher-data.cpp
          lib/switcher-data.hpp
          lib/version.cpp
          lib/version.h)

# Legacy function sources
target_sources(
  ${LIB_NAME}
  PRIVATE lib/legacy/scene-group.cpp
          lib/legacy/scene-group.hpp
          lib/legacy/switch-audio.cpp
          lib/legacy/switch-audio.hpp
          lib/legacy/switch-executable.cpp
          lib/legacy/switch-executable.hpp
          lib/legacy/switch-file.cpp
          lib/legacy/switch-file.hpp
          lib/legacy/switch-generic.cpp
          lib/legacy/switch-generic.hpp
          lib/legacy/switch-idle.cpp
          lib/legacy/switch-idle.hpp
          lib/legacy/switch-media.cpp
          lib/legacy/switch-media.hpp
          lib/legacy/switch-pause.cpp
          lib/legacy/switch-pause.hpp
          lib/legacy/switch-random.cpp
          lib/legacy/switch-random.hpp
          lib/legacy/switch-screen-region.cpp
          lib/legacy/switch-screen-region.hpp
          lib/legacy/switch-sequence.cpp
          lib/legacy/switch-sequence.hpp
          lib/legacy/switch-time.cpp
          lib/legacy/switch-time.hpp
          lib/legacy/switch-transitions.cpp
          lib/legacy/switch-transitions.hpp
          lib/legacy/switch-video.cpp
          lib/legacy/switch-video.hpp
          lib/legacy/switch-window.cpp
          lib/legacy/switch-window.hpp)

# Maro sources
target_sources(
  ${LIB_NAME}
  PRIVATE lib/macro/macro-action-edit.cpp
          lib/macro/macro-action-edit.hpp
          lib/macro/macro-action-factory.cpp
          lib/macro/macro-action-factory.hpp
          lib/macro/macro-action-macro.cpp
          lib/macro/macro-action-macro.hpp
          lib/macro/macro-action-queue.cpp
          lib/macro/macro-action-queue.hpp
          lib/macro/macro-action-variable.cpp
          lib/macro/macro-action-variable.hpp
          lib/macro/macro-action.cpp
          lib/macro/macro-action.hpp
          lib/macro/macro-condition-edit.cpp
          lib/macro/macro-condition-edit.hpp
          lib/macro/macro-condition-factory.cpp
          lib/macro/macro-condition-factory.hpp
          lib/macro/macro-condition-macro.cpp
          lib/macro/macro-condition-macro.hpp
          lib/macro/macro-condition-queue.cpp
          lib/macro/macro-condition-queue.hpp
          lib/macro/macro-condition-tempvar.cpp
          lib/macro/macro-condition-tempvar.hpp
          lib/macro/macro-condition-variable.cpp
          lib/macro/macro-condition-variable.hpp
          lib/macro/macro-condition.cpp
          lib/macro/macro-condition.hpp
          lib/macro/macro-dock.cpp
          lib/macro/macro-dock.hpp
          lib/macro/macro-dock-settings.hpp
          lib/macro/macro-dock-settings.cpp
          lib/macro/macro-dock-window.cpp
          lib/macro/macro-dock-window.hpp
          lib/macro/macro-edit.cpp
          lib/macro/macro-edit.hpp
          lib/macro/macro-export-import-dialog.cpp
          lib/macro/macro-export-import-dialog.hpp
          lib/macro/macro-helpers.cpp
          lib/macro/macro-helpers.hpp
          lib/macro/macro-input.cpp
          lib/macro/macro-input.hpp
          lib/macro/macro-list.cpp
          lib/macro/macro-list.hpp
          lib/macro/macro-ref.cpp
          lib/macro/macro-ref.hpp
          lib/macro/macro-run-button.cpp
          lib/macro/macro-run-button.hpp
          lib/macro/macro-search.cpp
          lib/macro/macro-search.hpp
          lib/macro/macro-segment-copy-paste.cpp
          lib/macro/macro-segment-copy-paste.hpp
          lib/macro/macro-segment-list.cpp
          lib/macro/macro-segment-list.hpp
          lib/macro/macro-segment-selection.cpp
          lib/macro/macro-segment-selection.hpp
          lib/macro/macro-segment-unknown.hpp
          lib/macro/macro-segment.cpp
          lib/macro/macro-segment.hpp
          lib/macro/macro-selection.cpp
          lib/macro/macro-selection.hpp
          lib/macro/macro-settings.cpp
          lib/macro/macro-settings.hpp
          lib/macro/macro-signals.cpp
          lib/macro/macro-signals.hpp
          lib/macro/macro-tab.cpp
          lib/macro/macro-tree.cpp
          lib/macro/macro-tree.hpp
          lib/macro/macro-websocket-trigger.cpp
          lib/macro/macro.cpp
          lib/macro/macro.hpp)

# Utility function sources
target_sources(
  ${LIB_NAME}
  PRIVATE lib/queue/action-queue.cpp
          lib/queue/action-queue.hpp
          lib/queue/action-queue-tab.cpp
          lib/queue/action-queue-tab.hpp
          lib/utils/auto-update-tooltip-label.cpp
          lib/utils/auto-update-tooltip-label.hpp
          lib/utils/backup.cpp
          lib/utils/backup.hpp
          lib/utils/canvas-helpers.cpp
          lib/utils/canvas-helpers.hpp
          lib/utils/condition-logic.cpp
          lib/utils/condition-logic.hpp
          lib/utils/crash-handler.cpp
          lib/utils/crash-handler.hpp
          lib/utils/curl-helper.cpp
          lib/utils/curl-helper.hpp
          lib/utils/cursor-shape-changer.cpp
          lib/utils/cursor-shape-changer.hpp
          lib/utils/double-slider.cpp
          lib/utils/double-slider.hpp
          lib/utils/duration-control.cpp
          lib/utils/duration-control.hpp
          lib/utils/duration-modifier.cpp
          lib/utils/duration-modifier.hpp
          lib/utils/duration.cpp
          lib/utils/duration.hpp
          lib/utils/export-symbol-helper.hpp
          lib/utils/file-selection.cpp
          lib/utils/file-selection.hpp
          lib/utils/filter-combo-box.cpp
          lib/utils/filter-combo-box.hpp
          lib/utils/help-icon.hpp
          lib/utils/help-icon.cpp
          lib/utils/item-selection-helpers.cpp
          lib/utils/item-selection-helpers.hpp
          lib/utils/json-helpers.cpp
          lib/utils/json-helpers.hpp
          lib/utils/layout-helpers.cpp
          lib/utils/layout-helpers.hpp
          lib/utils/list-controls.cpp
          lib/utils/list-controls.hpp
          lib/utils/list-editor.cpp
          lib/utils/list-editor.hpp
          lib/utils/log-helper.cpp
          lib/utils/log-helper.hpp
          lib/utils/math-helpers.cpp
          lib/utils/math-helpers.hpp
          lib/utils/message-buffer.hpp
          lib/utils/message-dispatcher.hpp
          lib/utils/mouse-wheel-guard.cpp
          lib/utils/mouse-wheel-guard.hpp
          lib/utils/name-dialog.cpp
          lib/utils/name-dialog.hpp
          lib/utils/non-modal-dialog.cpp
          lib/utils/non-modal-dialog.hpp
          lib/utils/obs-module-helper.cpp
          lib/utils/obs-module-helper.hpp
          lib/utils/path-helpers.cpp
          lib/utils/path-helpers.hpp
          lib/utils/plugin-state-helpers.cpp
          lib/utils/plugin-state-helpers.hpp
          lib/utils/priority-helper.cpp
          lib/utils/priority-helper.hpp
          lib/utils/regex-config.cpp
          lib/utils/regex-config.hpp
          lib/utils/resizable-widget.cpp
          lib/utils/resizable-widget.hpp
          lib/utils/resizing-text-edit.cpp
          lib/utils/resizing-text-edit.hpp
          lib/utils/resource-table.cpp
          lib/utils/resource-table.hpp
          lib/utils/scene-selection.cpp
          lib/utils/scene-selection.hpp
          lib/utils/scene-switch-helpers.cpp
          lib/utils/scene-switch-helpers.hpp
          lib/utils/screenshot-helper.cpp
          lib/utils/screenshot-helper.hpp
          lib/utils/section.cpp
          lib/utils/section.hpp
          lib/utils/selection-helpers.cpp
          lib/utils/selection-helpers.hpp
          lib/utils/single-char-selection.cpp
          lib/utils/single-char-selection.hpp
          lib/utils/slider-spinbox.cpp
          lib/utils/slider-spinbox.hpp
          lib/utils/source-helpers.cpp
          lib/utils/source-helpers.hpp
          lib/utils/source-selection.cpp
          lib/utils/source-selection.hpp
          lib/utils/splitter-helpers.cpp
          lib/utils/splitter-helpers.hpp
          lib/utils/status-control.cpp
          lib/utils/status-control.hpp
          lib/utils/string-list.cpp
          lib/utils/string-list.hpp
          lib/utils/switch-button.cpp
          lib/utils/switch-button.hpp
          lib/utils/sync-helpers.cpp
          lib/utils/sync-helpers.hpp
          lib/utils/tab-helpers.cpp
          lib/utils/tab-helpers.hpp
          lib/utils/temp-variable.cpp
          lib/utils/temp-variable.hpp
          lib/utils/time-helpers.cpp
          lib/utils/time-helpers.hpp
          lib/utils/ui-helpers.cpp
          lib/utils/ui-helpers.hpp
          lib/utils/utility.cpp
          lib/utils/utility.hpp
          lib/utils/volume-control.cpp
          lib/utils/volume-control.hpp
          lib/utils/websocket-api.cpp
          lib/utils/websocket-api.hpp
          lib/variables/variable-line-edit.cpp
          lib/variables/variable-line-edit.hpp
          lib/variables/variable-number.hpp
          lib/variables/variable-number.tpp
          lib/variables/variable-spinbox.cpp
          lib/variables/variable-spinbox.hpp
          lib/variables/variable-string.cpp
          lib/variables/variable-string.hpp
          lib/variables/variable-tab.cpp
          lib/variables/variable-tab.hpp
          lib/variables/variable-text-edit.cpp
          lib/variables/variable-text-edit.hpp
          lib/variables/variable.cpp
          lib/variables/variable.hpp)

# --- End of section ---

# Subfolder for advanced scene switcher plugins
set(ADVSS_PLUGIN_FOLDER "advanced-scene-switcher-plugins")
target_compile_definitions(
  ${LIB_NAME} PRIVATE ADVSS_PLUGIN_FOLDER=\"${ADVSS_PLUGIN_FOLDER}\")

include(cmake/common/advss_helpers.cmake)
setup_obs_lib_dependency(${LIB_NAME})
setup_obs_lib_dependency(${PROJECT_NAME})

find_package(Qt6 REQUIRED COMPONENTS Widgets Core)
target_link_libraries(${PROJECT_NAME} PRIVATE Qt6::Core Qt6::Widgets)
target_link_libraries(${LIB_NAME} PRIVATE Qt6::Core Qt6::Widgets)

# Ignore QCheckBox::stateChanged deprecation warning until minimum supported Qt
# version is at least Qt 6.7, which introduces QCheckBox::checkStateChanged
if(Qt6_VERSION VERSION_GREATER "6.0.0")
  target_compile_definitions(${LIB_NAME} PRIVATE QT_NO_DEPRECATED_WARNINGS)
endif()

target_compile_options(
  ${PROJECT_NAME}
  PRIVATE

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)
project(advanced-scene-switcher-tests)

get_target_property(ADVSS_SOURCE_DIR advanced-scene-switcher-lib SOURCE_DIR)
add_executable(${PROJECT_NAME})
target_compile_definitions(${PROJECT_NAME} PRIVATE UNIT_TEST)
target_compile_features(${PROJECT_NAME} PRIVATE cxx_std_17)

target_sources(
  ${PROJECT_NAME} PRIVATE test-main.cpp mocks/obs-data.cpp
                          mocks/path-helpers.cpp mocks/ui-helpers.cpp)
target_include_directories(
  ${PROJECT_NAME}
  PRIVATE mocks ${ADVSS_SOURCE_DIR}/lib/utils ${ADVSS_SOURCE_DIR}/lib/variables
          ${ADVSS_SOURCE_DIR}/plugins/base/utils)

# --- Qt --- #

target_link_libraries(${PROJECT_NAME} PUBLIC Qt::Core Qt::Widgets)

if(TARGET Qt6::Core)
  set(_QT_VERSION
      6
      CACHE INTERNAL "")
elseif(TARGET Qt5::Core)
  set(_QT_VERSION
      5
      CACHE INTERNAL "")
endif()

macro(add_qt_lib lib_name)
  add_custom_command(
    TARGET ${PROJECT_NAME}
    POST_BUILD
    COMMAND
      ${CMAKE_COMMAND} -E copy_if_different
      $<TARGET_FILE:Qt${_QT_VERSION}::${lib_name}>
      $<TARGET_FILE_DIR:${PROJECT_NAME}>)
endmacro()

add_qt_lib(Core)
add_qt_lib(Gui)
add_qt_lib(Widgets)

set_target_properties(
  ${PROJECT_NAME}
  PROPERTIES AUTOMOC ON
             AUTOUIC ON
             AUTORCC ON)

# --- condition-logic --- #

target_sources(
  ${PROJECT_NAME} PRIVATE test-condition-logic.cpp
                          ${ADVSS_SOURCE_DIR}/lib/utils/condition-logic.cpp)

# --- duration-modifier --- #

target_sources(
  ${PROJECT_NAME}
  PRIVATE test-duration-modifier.cpp
          ${ADVSS_SOURCE_DIR}/lib/utils/duration-modifier.cpp
          ${ADVSS_SOURCE_DIR}/lib/utils/duration.cpp)

# --- json --- #

if(TARGET jsoncons)
  target_link_libraries(${PROJECT_NAME} PRIVATE jsoncons)
  target_compile_definitions(${PROJECT_NAME} PRIVATE JSONPATH_SUPPORT=1)
endif()
target_link_libraries(${PROJECT_NAME} PUBLIC nlohmann_json::nlohmann_json)
target_sources(
  ${PROJECT_NAME} PRIVATE test-json.cpp
                          ${ADVSS_SOURCE_DIR}/lib/utils/json-helpers.cpp)

# --- math --- #

target_sources(
  ${PROJECT_NAME}
  PRIVATE test-math.cpp ${ADVSS_SOURCE_DIR}/lib/utils/math-helpers.cpp
          ${ADVSS_SOURCE_DIR}/lib/utils/obs-module-helper.cpp)
target_include_directories(${PROJECT_NAME}
                           PRIVATE ${ADVSS_SOURCE_DIR}/deps/exprtk)

if(MSVC)
  target_compile_options(${PROJECT_NAME} PUBLIC /MP /d2FH4- /wd4267 /wd4267
                                                /bigobj)
else()
  target_compile_options(
    ${PROJECT_NAME} PUBLIC -Wno-error=unused-parameter -Wno-error=conversion
                           -Wno-error=unused-value)
endif()

# --- regex --- #

target_sources(
  ${PROJECT_NAME}
  PRIVATE test-regex.cpp ${ADVSS_SOURCE_DIR}/lib/utils/regex-config.cpp
          ${ADVSS_SOURCE_DIR}/plugins/base/utils/text-helpers.cpp)

# --- utility --- #

target_sources(
  ${PROJECT_NAME} PRIVATE test-utility.cpp
                          ${ADVSS_SOURCE_DIR}/lib/utils/utility.cpp)

# --- variable --- #

if(OS_WINDOWS)
  target_compile_options(${PROJECT_NAME} PRIVATE /wd4100)
else()
  target_compile_options(${PROJECT_NAME} PRIVATE -Wno-error=shadow
                                                 -Wno-unused-parameter)
endif()

target_sources(
  ${PROJECT_NAME}
  PRIVATE test-variable.cpp
          ${ADVSS_SOURCE_DIR}/lib/utils/filter-combo-box.cpp
          ${ADVSS_SOURCE_DIR}/lib/utils/item-selection-helpers.cpp
          ${ADVSS_SOURCE_DIR}/lib/utils/name-dialog.cpp
          ${ADVSS_SOURCE_DIR}/lib/utils/resizing-text-edit.cpp
          ${ADVSS_SOURCE_DIR}/lib/variables/variable.cpp)

# --- #

enable_testing()

=== plugins/base/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)
project(advanced-scene-switcher-base)

add_library(${PROJECT_NAME} MODULE)

target_sources(
  ${PROJECT_NAME}
  PRIVATE macro-action-audio.cpp
          macro-action-audio.hpp
          macro-action-clipboard.cpp
          macro-action-clipboard.hpp
          macro-action-file.cpp
          macro-action-file.hpp
          macro-action-filter.cpp
          macro-action-filter.hpp
          macro-action-hotkey.cpp
          macro-action-hotkey.hpp
          macro-action-http-legacy.cpp
          macro-action-http-legacy.hpp
          macro-action-log.cpp
          macro-action-log.hpp
          macro-action-media.cpp
          macro-action-media.hpp
          macro-action-obs-settings.cpp
          macro-action-obs-settings.hpp
          macro-action-osc.cpp
          macro-action-osc.hpp
          macro-action-plugin-state.cpp
          macro-action-plugin-state.hpp
          macro-action-profile.cpp
          macro-action-profile.hpp
          macro-action-projector.cpp
          macro-action-projector.hpp
          macro-action-random.cpp
          macro-action-random.hpp
          macro-action-recording.cpp
          macro-action-recording.hpp
          macro-action-replay-buffer.cpp
          macro-action-replay-buffer.hpp
          macro-action-run.cpp
          macro-action-run.hpp
          macro-action-scene-collection.cpp
          macro-action-scene-collection.hpp
          macro-action-scene-lock.cpp
          macro-action-scene-lock.hpp
          macro-action-scene-order.cpp
          macro-action-scene-order.hpp
          macro-action-scene-switch.cpp
          macro-action-scene-switch.hpp
          macro-action-scene-transform.cpp
          macro-action-scene-transform.hpp
          macro-action-scene-visibility.cpp
          macro-action-scene-visibility.hpp
          macro-action-screenshot.cpp
          macro-action-screenshot.hpp
          macro-action-sequence.cpp
          macro-action-sequence.hpp
          macro-action-source.cpp
          macro-action-source.hpp
          macro-action-streaming.cpp
          macro-action-streaming.hpp
          macro-action-studio-mode.cpp
          macro-action-studio-mode.hpp
          macro-action-systray.cpp
          macro-action-systray.hpp
          macro-action-timer.cpp
          macro-action-timer.hpp
          macro-action-transition.cpp
          macro-action-transition.hpp
          macro-action-virtual-cam.cpp
          macro-action-virtual-cam.hpp
          macro-action-wait.cpp
          macro-action-wait.hpp
          macro-action-websocket.cpp
          macro-action-websocket.hpp
          macro-action-window.cpp
          macro-action-window.hpp
          macro-condition-audio.cpp
          macro-condition-audio.hpp
          macro-condition-clipboard.cpp
          macro-condition-clipboard.hpp
          macro-condition-cursor.cpp
          macro-condition-cursor.hpp
          macro-condition-date.cpp
          macro-condition-date.hpp
          macro-condition-display.cpp
          macro-condition-display.hpp
          macro-condition-file.cpp
          macro-condition-file.hpp
          macro-condition-filter.cpp
          macro-condition-filter.hpp
          macro-condition-folder.cpp
          macro-condition-folder.hpp
          macro-condition-game-capture.cpp
          macro-condition-game-capture.hpp
          macro-condition-hotkey.cpp
          macro-condition-hotkey.hpp
          macro-condition-idle.cpp
          macro-condition-idle.hpp
          macro-condition-media.cpp
          macro-condition-media.hpp
          macro-condition-obs-stats.cpp
          macro-condition-obs-stats.hpp
          macro-condition-plugin-state.cpp
          macro-condition-plugin-state.hpp
          macro-condition-process.cpp
          macro-condition-process.hpp
          macro-condition-profile.cpp
          macro-condition-profile.hpp
          macro-condition-recording.cpp
          macro-condition-recording.hpp
          macro-condition-replay-buffer.cpp
          macro-condition-replay-buffer.hpp
          macro-condition-run.cpp
          macro-condition-run.hpp
          macro-condition-scene-order.cpp
          macro-condition-scene-order.hpp
          macro-condition-scene-transform.cpp
          macro-condition-scene-transform.hpp
          macro-condition-scene-visibility.cpp
          macro-condition-scene-visibility.hpp
          macro-condition-scene.cpp
          macro-condition-scene.hpp
          macro-condition-screenshot.cpp
          macro-condition-screenshot.hpp
          macro-condition-slideshow.cpp
          macro-condition-slideshow.hpp
          macro-condition-source.cpp
          macro-condition-source.hpp
          macro-condition-streaming.cpp
          macro-condition-streaming.hpp
          macro-condition-studio-mode.cpp
          macro-condition-studio-mode.hpp
          macro-condition-timer.cpp
          macro-condition-timer.hpp
          macro-condition-transition.cpp
          macro-condition-transition.hpp
          macro-condition-virtual-cam.cpp
          macro-condition-virtual-cam.hpp
          macro-condition-websocket.cpp
          macro-condition-websocket.hpp
          macro-condition-window.cpp
          macro-condition-window.hpp)

target_sources(
  ${PROJECT_NAME}
  PRIVATE utils/audio-helpers.cpp
          utils/audio-helpers.hpp
          utils/connection-manager.cpp
          utils/connection-manager.hpp
          utils/cursor-helpers.cpp
          utils/cursor-helpers.hpp
          utils/day-of-week-selector.cpp
          utils/day-of-week-selector.hpp
          utils/filter-selection.cpp
          utils/filter-selection.hpp
          utils/hotkey-helpers.cpp
          utils/hotkey-helpers.hpp
          utils/monitor-helpers.cpp
          utils/monitor-helpers.hpp
          utils/osc-helpers.cpp
          utils/osc-helpers.hpp
          utils/process-config.cpp
          utils/process-config.hpp
          utils/profile-helpers.cpp
          utils/profile-helpers.hpp
          utils/scene-item-selection.cpp
          utils/scene-item-selection.hpp
          utils/scene-item-transform-helpers.cpp
          utils/scene-item-transform-helpers.hpp
          utils/transition-helpers.cpp
          utils/transition-helpers.hpp
          utils/source-properties-button.cpp
          utils/source-properties-button.hpp
          utils/source-settings-helpers.cpp
          utils/source-settings-helpers.hpp
          utils/source-setting.cpp
          utils/source-setting.hpp
          utils/striped-frame.cpp
          utils/striped-frame.hpp
          utils/text-helpers.cpp
          utils/text-helpers.hpp
          utils/transform-setting.cpp
          utils/transform-setting.hpp
          utils/transition-selection.cpp
          utils/transition-selection.hpp
          utils/websocket-helpers.cpp
          utils/websocket-helpers.hpp
          utils/websocket-tab.cpp
          utils/websocket-tab.hpp
          utils/window-selection.cpp
          utils/window-selection.hpp)

if(OS_WINDOWS)
  target_sources(${PROJECT_NAME} PRIVATE utils/windows/windows.cpp)
elseif(OS_MACOS)
  target_sources(${PROJECT_NAME} PRIVATE utils/osx/osx.mm)
else()
  target_sources(${PROJECT_NAME} PRIVATE utils/linux/linux.cpp)
  find_package(X11 REQUIRED COMPONENTS Xtst)
  target_include_directories(${PROJECT_NAME} PRIVATE "${X11_INCLUDE_DIR}"
                                                     "${X11_Xtst_INCLUDE_PATH}")
  target_link_libraries(${PROJECT_NAME} PRIVATE ${X11_LIBRARIES})
endif()

target_include_directories(${PROJECT_NAME}
                           PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}/utils")
get_target_property(ADVSS_SOURCE_DIR advanced-scene-switcher-lib SOURCE_DIR)
add_definitions(-DASIO_STANDALONE)
target_include_directories(
  ${LIB_NAME}
  PUBLIC "${ADVSS_SOURCE_DIR}/deps/asio/asio/include"
         "${ADVSS_SOURCE_DIR}/deps/websocketpp"
         "${ADVSS_SOURCE_DIR}/deps/obs-websocket/lib")

setup_advss_plugin(${PROJECT_NAME})
set_target_properties(${PROJECT_NAME} PROPERTIES PREFIX "")
install_advss_plugin(${PROJECT_NAME})

=== plugins/twitch/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)
project(advanced-scene-switcher-twitch)

# --- Check requirements ---

get_target_property(ADVSS_SOURCE_DIR advanced-scene-switcher-lib SOURCE_DIR)
set(CPP_HTTPLIB_DIR "${ADVSS_SOURCE_DIR}/deps/cpp-httplib")
if(NOT EXISTS "${CPP_HTTPLIB_DIR}/CMakeLists.txt")
  message(WARNING "cpp-httplib directory \"${CPP_HTTPLIB_DIR}\" not found!\n"
                  "Twitch support will be disabled!")
  return()
endif()
if(NOT TARGET httplib)
  add_subdirectory("${CPP_HTTPLIB_DIR}" "${CPP_HTTPLIB_DIR}/build"
                   EXCLUDE_FROM_ALL)
endif()

if(OS_MACOS)
  set(OPENSSL_USE_STATIC_LIBS
      ON
      CACHE BOOL "Use static OpenSSL" FORCE)
endif()
find_package(OpenSSL)
if(NOT OPENSSL_FOUND)
  message(WARNING "OpenSSL not found!\n" "Twitch support will be disabled!\n\n")
  return()
endif()

find_package(ZLIB)
if(NOT ZLIB_FOUND)
  message(WARNING "zlib not found!\n" "Twitch support will be disabled!\n\n")
  return()
endif()

set(DATE_LIB_DIR "${ADVSS_SOURCE_DIR}/deps/date")
if(EXISTS "${DATE_LIB_DIR}/CMakeLists.txt"
   AND NOT DISABLE_TWITCH_TIMESTAMP_VERIFICATION)
  set(BUILD_TZ_LIB ON)
  if(OS_WINDOWS)
    if(CURL_FOUND AND TARGET CURL::libcurl)
      get_target_property(CURL_INCLUDE_DIR CURL::libcurl
                          INTERFACE_INCLUDE_DIRECTORIES)
      add_subdirectory("${DATE_LIB_DIR}" "${DATE_LIB_DIR}/build"
                       EXCLUDE_FROM_ALL)
      target_include_directories(date-tz PRIVATE "${CURL_INCLUDE_DIR}")
      set(VERIFY_TWITCH_TIMESTAMPS ON)
    else()
      message(WARNING "CURL not found - not verifying Twitch timestamps")
    endif()
  else()
    add_subdirectory("${DATE_LIB_DIR}" "${DATE_LIB_DIR}/build" EXCLUDE_FROM_ALL)
    target_compile_options(date-tz PUBLIC -Wno-error=conversion
                                          -Wno-error=shadow)
    set(VERIFY_TWITCH_TIMESTAMPS ON)
  endif()
else()
  message(WARNING "date lib not found in \"${DATE_LIB_DIR}\"!\n"
                  "Twitch timestamps will not be checked!")
endif()

# --- End of section ---

add_library(${PROJECT_NAME} MODULE)
target_compile_definitions(
  ${PROJECT_NAME} PRIVATE CPPHTTPLIB_OPENSSL_SUPPORT=1 ASIO_STANDALONE=1
                          ASIO_HAS_OPENSSSL=1)
target_include_directories(
  ${PROJECT_NAME} PUBLIC "${ADVSS_SOURCE_DIR}/deps/asio/asio/include"
                         "${ADVSS_SOURCE_DIR}/deps/websocketpp")
if(OS_MACOS)
  target_compile_definitions(
    ${PROJECT_NAME} PRIVATE CPPHTTPLIB_USE_CERTS_FROM_MACOSX_KEYCHAIN=1)
  target_link_libraries(${PROJECT_NAME} PRIVATE "-framework CoreFoundation")
  target_link_libraries(${PROJECT_NAME} PRIVATE "-framework Security")
endif()

if(MSVC)
  target_compile_options(${PROJECT_NAME} PRIVATE /wd4834)
endif()

target_sources(
  ${PROJECT_NAME}
  PRIVATE category-selection.cpp
          category-selection.hpp
          channel-selection.cpp
          channel-selection.hpp
          chat-connection.cpp
          chat-connection.hpp
          chat-message-pattern.cpp
          chat-message-pattern.hpp
          content-classification.cpp
          content-classification.hpp
          event-sub.cpp
          event-sub.hpp
          language-selection.cpp
          language-selection.hpp
          macro-action-twitch.cpp
          macro-action-twitch.hpp
          macro-condition-twitch.cpp
          macro-condition-twitch.hpp
          points-reward-selection.cpp
          points-reward-selection.hpp
          tag-selection.cpp
          tag-selection.hpp
          token.cpp
          token.hpp
          twitch-helpers.cpp
          twitch-helpers.hpp
          twitch-tab.cpp
          twitch-tab.hpp)

setup_advss_plugin(${PROJECT_NAME})
set_target_properties(${PROJECT_NAME} PROPERTIES PREFIX "")
target_include_directories(${PROJECT_NAME} PRIVATE "${CPP_HTTPLIB_DIR}/"
                                                   "${OPENSSL_INCLUDE_DIR}")
target_link_libraries(${PROJECT_NAME} PRIVATE ${OPENSSL_LIBRARIES} ZLIB::ZLIB)
if(DEFINED VERIFY_TWITCH_TIMESTAMPS)
  target_compile_definitions(${PROJECT_NAME} PRIVATE VERIFY_TIMESTAMPS=1)
  target_link_libraries(${PROJECT_NAME} PRIVATE date::date-tz)
  if(OS_WINDOWS)
    target_link_libraries(${PROJECT_NAME} PRIVATE CURL::libcurl)
  endif()
endif()

install_advss_plugin(${PROJECT_NAME})
if(OS_WINDOWS)
  # Couldn't really find a better way to install runtime dependencies for
  # Windows TODO: Clean this up at some point
  function(FIND_FILES_WITH_PATTERN result pattern dir)
    execute_process(
      COMMAND
        powershell -Command
        "Get-ChildItem -Path '${dir}' -Recurse -Include ${pattern} |"
        "Select-Object -First 1 |"
        "ForEach-Object { $_.FullName -replace '\\\\', '\\\\' }"
      OUTPUT_VARIABLE files
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    set(${result}
        ${files}
        PARENT_SCOPE)
  endfunction()

  set(OPENSSL_DLL_SEARCH_DIR "${OPENSSL_INCLUDE_DIR}/..")
  find_files_with_pattern(CRYPTO_DLL_FILES "libcrypto*.dll"
                          "${OPENSSL_DLL_SEARCH_DIR}")
  find_files_with_pattern(SSL_DLL_FILES "libssl*.dll"
                          "${OPENSSL_DLL_SEARCH_DIR}")
  install_advss_plugin_dependency(TARGET ${PROJECT_NAME} DEPENDENCIES
                                  "${CRYPTO_DLL_FILES}" "${SSL_DLL_FILES}")
endif()

=== debian/changelog ===
obs-advanced-scene-switcher (1.32.8-1) unstable; urgency=medium

  * New upstream version 1.32.8.
  * debian/control:
      - Bumped Standards-Version to 4.7.3.
      - Removed no longer needed "Priority: optional" field.
      - Removed no longer needed "Rules-Requires-Root: no" field.
      - Updated dependencies to require libobs-dev and obs-studio >= 32.
        (Closes: #1128465)
  * debian/copyright: updated upstream and packaging copyright years.
  * debian/rules: added override for blhc to ignore CMake ABI tests.
  * debian/watch: migrated to version 5.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 23 Feb 2026 21:18:38 -0300

=== debian/control ===
Source: obs-advanced-scene-switcher
Section: video
Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libasio-dev,
               libcurl4-openssl-dev,
               libobs-dev (>= 32),
               libopencv-dev,
               libproc2-dev | libprocps-dev,
               libusb-1.0-0-dev,
               libxkbcommon-dev,
               libxss-dev,
               libxtst-dev,
               libwebsocketpp-dev,
               nlohmann-json3-dev,
               qt6-base-dev
Standards-Version: 4.7.3
Homepage: https://obsproject.com/forum/resources/advanced-scene-switcher.395/
Vcs-Browser: https://salsa.debian.org/debian/obs-advanced-scene-switcher
Vcs-Git: https://salsa.debian.org/debian/obs-advanced-scene-switcher.git

Package: obs-advanced-scene-switcher
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ${lib:Depends},
         obs-advanced-scene-switcher-data (>= 1.16.3-1~),
         obs-studio (>= 32)
Enhances: obs-studio
Description: plugin for OBS Studio to improve the scene switching
 Advanced Scene Switcher plugin is based on the built-in Automatic Scene
 Switcher. It extends its functionality by adding the following:
 .
   - Audio based scene switching (Audio tab).
   - Media based scene switching (Media tab).
   - System time based scene switching (Time tab).
   - Sequence of automated scene switches (Scene Sequence tab).
   - Cursor position based scene switching (Region).
   - The option to switch to a scene after detection of being idle (Idle tab).
   - Executable based scene switching (Executable tab).
   - File content based scene switching (File).
   - Improvements for the window title based scene switching (full-screen /
     maximized detection, ignore windows).
   - The ability select a different transition for each automated switch case
     (Transitions tab).
   - Automatically pause the scene switcher based on scene or window title
     hotkey to start and stop the scene switcher.
   - Trigger actions on scene change.
   - and more ...

Package: obs-advanced-scene-switcher-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Enhances: obs-studio
Breaks: obs-advanced-scene-switcher (<< 1.16.1~),
        obs-text-slideshow (<= 1.5.2-3)
Replaces: obs-advanced-scene-switcher (<< 1.16.1~)
Description: data package for obs-advanced-scene-switcher
 Advanced Scene Switcher plugin is based on the built-in
 Automatic Scene Switcher.
 .
 This package provides architecture-independent data for
 obs-advanced-scene-switcher.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Exclude "obs-" from NAME and set a DEST
export PLUGIN_NAME=$(shell echo ${DEB_SOURCE} | cut -d"-" -f2-)
export PLUGIN_DEST=debian/${DEB_SOURCE}/usr/lib/${DEB_TARGET_MULTIARCH}/obs-plugins

%:
	dh $@

# Using DEB_INSTALL, BUILD_OUT_OF_TREE will automatically be detected.
override_dh_auto_configure:
	dh_auto_configure -- -DDEB_INSTALL=ON \
                             -DLINUX_PORTABLE=OFF \
                             -DCMAKE_INSTALL_PREFIX=/usr \
                             -DLIBOBS_INCLUDE_DIR=/usr/include/obs \
                             -DLIBOBS_LIB=/usr/lib/${DEB_TARGET_MULTIARCH}/libobs.so \
                             -DLIBOBS_FRONTEND_INCLUDE_DIR=/usr/include/obs \
                             -DLIBOBS_FRONTEND_API_LIB=/usr/lib/${DEB_TARGET_MULTIARCH}/libobs-frontend-api.so \
                             -DLIB_OUT_DIR=lib/${DEB_TARGET_MULTIARCH}/obs-plugins \
                             -DDATA_OUT_DIR=share/obs/obs-plugins/$(PLUGIN_NAME)

# blhc should ignore CMake ABI tests.
execute_before_dh_auto_build:
	@echo 'blhc: ignore-line-regexp: /usr/bin/c\+\+ .*/Modules/CMakeCXXCompilerABI\.cpp .*'

execute_after_dh_install-arch:
	# Check if the plugin is in right place
	ls $(PLUGIN_DEST)/lib$(PLUGIN_NAME).so

# Solves #1068414. Thanks to Matthias Klose <doko@ubuntu.com>.
override_dh_gencontrol:
	dh_gencontrol -- \
	  -Vlib:Depends=$(shell dpkg-query -W -f '$${Depends}' libcurl4-openssl-dev \
			| sed -E 's/.*(libcurl[[:digit:]][[:alnum:].-]+).*/\1/')

=== debian/watch ===
Version: 5

Template: Github
Owner: WarmUpTill
Project: SceneSwitcher
